Last Comment Bug 632634 - Use longer hover link popup for long URLs
: Use longer hover link popup for long URLs
Status: RESOLVED FIXED
: polish, ux-efficiency
Product: Firefox
Classification: Client Software
Component: General (show other bugs)
: Trunk
: All All
: -- enhancement with 13 votes (vote)
: Firefox 14
Assigned To: Dão Gottwald [:dao]
:
Mentors:
: 622374 640388 647457 658918 667149 673830 720287 (view as bug list)
Depends on:
Blocks: 541656
  Show dependency treegraph
 
Reported: 2011-02-08 17:37 PST by Dave Garrett
Modified: 2013-04-05 19:16 PDT (History)
32 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
patch (2.16 KB, patch)
2012-04-10 09:13 PDT, Dão Gottwald [:dao]
felipc: review+
Details | Diff | Splinter Review

Description Dave Garrett 2011-02-08 17:37:08 PST
An example really long URL:
http://www.google.com/search?q=thisisalongurltestaaaaaaaaaaaaaaaaaaaaaaaaaaaaa12345&ie=utf-8&oe=utf-8&aq=t&rls=org.mozilla:en-US:unofficial&client=firefox-a

Hover over the above link in current Trunk and it'll truncate to fit into a popup bubble half the width of the browser in the lower left. Since we're now showing this on top of content rather than in a fixed space in the status or location bar, we've got more room to spare. We should at least show as much of it as we can so the user is more informed. There's no need to truncate it if we have the room.

Really long URLs are a known potential spoofing path, so showing as much as possible is potentially helpful in this area. (e.g. long URL with real URL it'll redirect to at the end) That being said, really long URLs that can't fit onscreen are also doable. Doing a marquee similar to what I suggested in bug 596802 might help with that, but that'd be another bug.

Using 100% of the browser width might be too much. Maybe up to 80% or so?
Comment 1 alex_mayorga 2011-02-09 10:42:35 PST
(In reply to comment #0)
> Using 100% of the browser width might be too much. Maybe up to 80% or so?

I'd vow for using 100% and making it the bubble multiple lines if need be.
To combat spoofing I should be as informed as I possibly can before clicking.

Can the bubble turn reddish if the destination is a known web forgery?
Comment 2 Dave Garrett 2011-02-09 10:54:46 PST
(In reply to comment #1)
> Can the bubble turn reddish if the destination is a known web forgery?

That's a really interesting idea, but way outside the scope of this bug.
Please file a new bug for that.
Comment 3 Dão Gottwald [:dao] 2011-02-15 15:20:36 PST
*** Bug 622374 has been marked as a duplicate of this bug. ***
Comment 4 Dão Gottwald [:dao] 2011-02-15 15:21:20 PST
The 50% max-width allows the panel to move to the other side to completely unblock content when needed.
Comment 5 Dave Garrett 2011-02-15 16:16:44 PST
The mirroring to unblock feature is only really needed for status update text, not link destination URLs. You can't hover the cursor over the status bubble to mirror it when it's for a link, as doing so would hover away from the link and hide it anyway. (in the keyboard only case, just tabbing away is all that would be needed to unblock content) Thus, the 50% max-width could be restricted to the status text case and a larger max-width could be used for link URLs.
Comment 6 Dão Gottwald [:dao] 2011-02-15 16:28:11 PST
No, links can be at the bottom of the content frame.
Comment 7 Dave Garrett 2011-02-15 18:42:02 PST
Ok, in that (literal) edge case the user still can unfocus the link to see any blocked content. The status update text, on the other hand, is not at the control of the user. In the instance of a link both being at the bottom of the screen and being particularly long, I think it's fine to trade off temporarily blocked page space to see more of the link because the user can always unfocus to get it back.
Comment 8 Gregor Gruber 2011-02-26 09:01:18 PST
But blocking a link with the bubble will cause flickering of the bubble/link/mouse cursor. The solution would be to move the bubble more flexible (not only to the far right side but also vertically) to a position where it can not interfere with the link. Another solution would be to ignore that the link is not visible while the bubble is there but make the bubble "click/hover through" so that it does not flicker and the link can still be clicked while the bubble is shown.
Comment 9 Please Ignore This Troll (Account Disabled) 2011-02-27 17:59:16 PST
(In reply to comment #4)
> The 50% max-width allows the panel to move to the other side to completely
> unblock content when needed.

why not use 100% of the width and move to the top edge of content video when needed?
Comment 10 Dão Gottwald [:dao] 2011-04-02 21:47:13 PDT
*** Bug 647457 has been marked as a duplicate of this bug. ***
Comment 11 Jaime Hablutzel 2011-04-04 14:21:08 PDT
80% with marquesine for longer links is my opinion
Comment 12 Virtual_ManPL [:Virtual] - (ni? me) 2011-04-04 14:31:11 PDT
We should use 100% of browser screen size IMO for the best efficiency.
Comment 13 Tim (fmdeveloper) 2011-04-17 15:08:20 PDT
*** Bug 640388 has been marked as a duplicate of this bug. ***
Comment 14 alex_mayorga 2011-04-17 15:40:43 PDT
(In reply to comment #2)
> (In reply to comment #1)
> > Can the bubble turn reddish if the destination is a known web forgery?
> 
> That's a really interesting idea, but way outside the scope of this bug.
> Please file a new bug for that.
Eventually filed bug 650687.
Comment 15 Tim (fmdeveloper) 2011-06-21 23:00:49 PDT
This seems to be resolved on trunk - Mozilla/5.0 (Windows NT 5.1; rv:7.0a1) Gecko/20110621 Firefox/7.0a1 ID:20110621030803

Close this bug?
Comment 16 Virtual_ManPL [:Virtual] - (ni? me) 2011-06-21 23:33:20 PDT
Not resolved - Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:7.0a1) Gecko/20110621 Firefox/7.0a1

Still Fx uses only 50% of screen space for long links.
Comment 17 Thomas Ahlblom 2011-06-25 14:28:49 PDT
*** Bug 658918 has been marked as a duplicate of this bug. ***
Comment 18 Nicolas Barbulesco 2011-06-27 06:56:24 PDT
(In reply to comment #0)

> Hover over the above link in current Trunk and it'll truncate to fit into a
> popup bubble half the width of the browser in the lower left. Since we're
> now showing this on top of content rather than in a fixed space in the
> status or location bar, we've got more room to spare. We should at least
> show as much of it as we can so the user is more informed. There's no need
> to truncate it if we have the room.

Exactly. Truncating harms. So let's truncate *only when we have to* truncate.

> Using 100% of the browser width might be too much. Maybe up to 80% or so?

I prefer 100 %.
Comment 19 Zac Spitzer 2011-07-06 21:18:54 PDT
Chrome's behaviour is to show the link initially truncated and the expands out to the full URL after a short delay.

I prefer 100%, abbreviating the URL achieves little and is annoying for developers
Comment 20 Nicolas Barbulesco 2011-07-07 02:37:20 PDT
(In reply to comment #19)

> Chrome's behaviour is to show the link initially truncated and the expands
> out to the full URL after a short delay.

This behaviour is less worse, but stills particularly annoys me. If you can
show the link after 2 seconds, then show it at once.
Comment 21 Adam 2011-07-07 03:30:34 PDT
I agree, it should show it all right away.  It's a big reason I use FF over Chrome where if it's too long, you just can't see it all.

Think about the people who actually use that in the first place.  They are either only interested in the domain, or they are going to want to see the entire link.  There's no purpose in only displaying a piece of it, it doesn't give any info to anyone who's going to bother looking.
Comment 22 George Carstoiu 2011-07-21 07:33:10 PDT
*** Bug 667149 has been marked as a duplicate of this bug. ***
Comment 23 Dan Jacobson 2011-08-03 13:05:39 PDT
*** Bug 673830 has been marked as a duplicate of this bug. ***
Comment 24 Dan Jacobson 2011-08-03 13:08:43 PDT
The author in Bug 673830 submits a convincing case on why,
he,
is,
going,
crazy.
Thanks to you not fixing this bug,
and
dragging your heels. See also http://bugs.debian.org/625829 .
Comment 25 Dan Jacobson 2011-08-03 13:23:46 PDT
Furthermore, forget about truncating. The bad guys will just figure out where to hide the juice in your latest choice of what sector to truncate.
Actually it is the good guys who are suffering... we now all have to hit 'view selection source' to compare two YouTube URLs with the differing part in the middle. Yes I wouldn't even truncate if they put a whole GIF image base 64 encoded into a URL...  OK... here's one.... OK, but at least give one FULL line at the bottom of the screen, not a half line. http://images.google.com/search?tbs=sbi:AMhZZivxXpfMlE0r3lPieKIQkrYqA59XTw738xH3xEKxT9L3el0SXvxC_1Ms2xS7ze8RtCUjFyrH-AaT0YXYPspbTOB_1irQDzdVcYuotRlDzsrDID81LEeFP7-Kp-Fl7W7kFsF7y_1yFocYP0tlNJk_17ihoRQ3LhLqN0PGW72ZP_1qz7GjO5-SoYF_1Oum2xDjh-z8kS8mYdKQ_1_1KhzdZApH-fVWbC_1HOXxCHAgvUQrLERv6CNILBy-pNevkktrOrO-9c7pqPcpo8VaYArR6C5A5O78W4_1CAXtENg1oxZuEtcS5pY2z3aK_1lhtJHTXxPLzJCgUc-oQJoZMa-XTp5kPegLVt9XXy2p7GVuVRnan3_1PqA0YSDYhcK8Agt0Re5W5zCLS0qONquf4w95VPK5PRaBIF_1aHp31Jn2T2uVWmWt8PpVbNIMTVAqlgVx2DvqRvY0acUMqhV2Hj60MpMFzz998oO9xwHoKq60yLP_1xvvVDCWg5hgN4kXPI7g9hXyTmgwegndEJSrpYsQbNsWaozYwvQj_1FSCzo8kmLFi6isDFan_1DwvwfmMZnHBBgoRW3TfZxNMH3ERUDxg2qFY9DQRuBJpC_1WViMKPFc7tddxJVBxJELFr3yNEzyj07VGOKyjj7CMM-RnTyQ2Pe-EvYA0vYaITTqJvqISvE_1TG5Az-ErtnE6cmlNOA2_1a_1irwUOmlAe70U908kycdyWAGb2d8BFbXPUUfCQ_1d6fyYSwuliG-z3PFttZtOGODGQPC_19Mn3rtphw1PnhW1GQp3eO0J-bW0vSk8bub1KwiUeEjZphbTMu_1ll59ufm4rgl19sSiD8LFVIhwmBH_1hDQzrFl8lyWGkfTnXxdcDNE9-GFmt58P8EGhzEG4PkWhNVTWQO-LVs4yz7TwSDDU_1BhnYgYlRinGOwX2Nbxg3m3_1pXkcQd0qT1oBKpck7zSEdqhNJNi6vNBbNljY1NubGUSJIiFBrCg-TC0q67TRHLZ0HDBHCznkir4O4j-A37S-hWcbjuhz1MlOYu1Mk2vYApsJfBCLb9z58dLXW65H6zobMmj2hG6gnnpymWhVnMvpi024-FEeLW6sDtInznTmjRvEFA48_1leLmCdXl6WbFxwYlbNkx6SxeoVPa7qwQ5ZPTmUsnvI0ZvWQXpyEUS51zSkiJkO3TpktgYwiv_1HOuWYWa2IMr4fsURYcNmnrHbKDyFLHcfPglHq7JUvulpK3uuwGwJfCi7L0U7tEI9NG-EwEy4axPFrR-fg4qErlaMVUUZKFCQVSF3Vkw_1KYKDjlsWTkDw-JWnSQdRtymSwui10WnKpV3g5r8SL7e2ot0MzHBGWB0&num=10&hl=en&safe=off&bih=767&biw=1024
Comment 26 Adam 2011-08-03 14:54:23 PDT
I'd like to see it even if it was that long.  Of course even I would see a huge inconvenience in a bar over say two lines high, that would take up a real good chunk of the screen.  So perhaps only if I mouse over it or wait a couple seconds.  The immediately visible portion of the url should cover 90% of urls without needing to wait or anything else and I think 2 lines would take care of that.
Comment 27 Matthieu Rivaud 2011-08-05 00:39:22 PDT
How about allowing the link preview to expand 100% in "normal" cases, but still limiting to 50% once it needs to switch side (link preview would stay at 50% until you hover another link, even if switched back to left) ?
Comment 28 Dan Jacobson 2011-08-05 15:49:55 PDT
(In reply to Matthieu Rivaud from comment #27)
Do something. Anything.
In the meantime it is like I'm driving around the Internet with this big
Garfield doll stuck right in the middle of my windshield.
If I crash into something, you guys are responsible!
Comment 29 Dan Jacobson 2011-08-09 04:51:10 PDT
What am I supposed to do.
Post URLs that I wished I could see the middles of,
every day until somebody fixes the bug?
http://www.facebook.com/l.php?u=http%3A%2F%2Fwww.facebook.com%2Fcampaign%2Flanding.php%3Fplacement%3Dpgaup_fbx_onpage%26campaign_id%3D365730201698%26extra_1%3D0%26fbid%3D119425868071153%26extra_2%3D2603%26keyword%3D3%26partner_id%3D2%26creative%3D119425868071153&h=CAQCEbvkG&cb=3&p=AT5esj7ecDzEO08GA5DpE2GAH5TyM6lwyio3zoTDpjczKuPdd03e4reWVzk8LFMBTWjLwrRX6Xp8WSHwuzxkESgGr8H0f99O_8_VcNq2etSuHA5hbLlictZ3MB8hpK0unXGnkp-_MMFVKD64
Is there some Plug-in stuff I can use in the meantime that your are Dragging your heels? Sure, the final result will be you lock me out of the bug tracker.
But this is having a big impact on my life.
What plug-in works to prevent this in FF7? Are you sure.
Comment 30 Dan Jacobson 2011-08-09 05:12:55 PDT
OK, a certain Lena told me about https://addons.mozilla.org/en-US/firefox/addon/url-tooltip/ ... when combined with https://addons.mozilla.org/en-US/firefox/addon/add-on-compatibility-reporter/ and when clicking [x]wrap long URLs in its preferences... I'm home free! No more hanging out on the deadsville bug page. See ya ... bye ... My Posse's On Broadway
http://www.youtube.com/watch?v=Lv4rLLvxsKk&list=PL38C412C876528CCB
Comment 31 Lena 2011-08-09 05:23:32 PDT
The "URL Tooltip" addon makes a tooltip near the hovered link, overlapping page text. So I'm still interested in improving the bottom-of-the-page popup.
Comment 32 Dan Jacobson 2011-08-09 05:33:04 PDT
(In reply to Lena from comment #31)
Yes, "I like Firefox little truncated-in-the-middle injured URL"
http://www.youtube.com/watch?v=v8aVKTVCJpM&list=PL6E40919035151385
ha ha ha... I'll be using the plugin for now until it gets fixed.
Comment 33 Dan Jacobson 2011-08-15 17:13:25 PDT
One notes that the plugins require the user to move the mouse on top of links.
Moving to the link via TAB will not bring satisfaction via plugins. Only fixing this bug can do that. Also are you sure the name 'hover" is correct in the bug title? As TABing to the link is not hovering, as the mouse is still hovering elsewhere.
Comment 34 Dan Jacobson 2011-08-20 15:34:34 PDT
Furthermore on links like
http://www.facebook.com/pages/%E5%82%BB%E5%82%BB%E5%8E%BB%E6%97%85%E8%A1%8C/100183500072083#!/profile.php?id=100000170944269
Firefox will thankfully show the rendered Unicode, whereas  the average plugin will only show the annoying %E5%82%BB codes, even if more of a security defense.
I.e., I'm still suffering waiting for Firefox to fix this, even though using the suggested plugins.
Comment 35 Dan Jacobson 2011-08-20 15:38:28 PDT
(In reply to jidanni from comment #34)
I'm saying that with e.g., hovering over
http://www.facebook.com/pages/%E5%82%BB%E5%82%BB%E5%8E%BB%E6%97%85%E8%A1%8C/100183500072083#!/profile.php?id=100000170944269
I can see spitefully truncated Chinese at the bottom of the screen, and spitefully raw % coded in the tooltip balloon provided by the plugin I was told to use.
So I'm still not happy.
Which it is your job to make me be.
If you get some spare time.
Comment 36 Nicolas Barbulesco 2011-08-25 14:47:11 PDT
The same problem occurs when I fly over an entry in the history panel.
Windows Vista. Firefox 4.0.1.
Comment 37 Dave Garrett 2011-08-25 16:19:13 PDT
(In reply to Nicolas Barbulesco from comment #36)
The same use-case problems don't apply as much with respect to bookmarks and history. You can always view the full URL via the Library ("Show All Bookmarks" / "Show All History"). The tooltips for these would be different from this issue, in any case.

Also, only latest Firefox, currently 6.0, and latest Firefox 3.6.x are supported by Mozilla so if you're running 4.0.1 still you really should update to at least get the security and stability updates.
Comment 38 Nicolas Barbulesco 2011-08-29 12:47:06 PDT
Yes, opening the history as the big window is a workaround.
But when I bring the history as the side panel and I fly over one of its entries, I get the annoying truncating in both the address that appears at the bottom and the address that appears in the yellow tooltip.
Firefox 4.0.1 Windows, Firefox 6.0 Mac.
Comment 39 sdnut 2011-08-31 20:11:02 PDT
tried to be good (clutter-free browsing) and became worse. at least firefox 3's same functionality should be back.
Comment 41 Virtual_ManPL [:Virtual] - (ni? me) 2012-01-06 06:55:35 PST
Agree! Not fully visible links are a bad idea and can be used in 'exploits'
Comment 42 Thomas Ahlblom 2012-01-22 19:48:12 PST
*** Bug 720287 has been marked as a duplicate of this bug. ***
Comment 43 Dão Gottwald [:dao] 2012-04-10 09:13:53 PDT
Created attachment 613634 [details] [diff] [review]
patch
Comment 44 :Felipe Gomes (needinfo me!) 2012-04-11 18:15:16 PDT
is it intentional that after unmirroring the sizelimit attribute is not removed?
Comment 45 Dão Gottwald [:dao] 2012-04-12 00:45:08 PDT
(In reply to Felipe Gomes (:felipe) from comment #44)
> is it intentional that after unmirroring the sizelimit attribute is not
> removed?

Yes, since the user could have moved the mouse back to the bottom right side. Limiting the size once the status panel had to be mirrored once simplifies things.
Comment 47 :Ms2ger (⌚ UTC+1/+2) 2012-04-12 10:18:59 PDT
https://hg.mozilla.org/mozilla-central/rev/7324a63f7855
Comment 48 Daniel Cater 2012-04-16 08:50:09 PDT
I like this change, but there is a slight edge case that isn't covered.

Scroll comment 29 so that the bottom right corner of the screen has part of the link in it. Hover over that part (by bringing the cursor up from underneath, or in from the right). The popup will appear on the right and truncated with the cursor on top of it. This requires an extra mousemove to switch the popup back over to the left.

Note You need to log in before you can comment on or make changes to this bug.